diff --git a/src/core/wee-network.c b/src/core/wee-network.c
index a37be51..e6e98e6 100644
--- a/src/core/wee-network.c
+++ b/src/core/wee-network.c
@@ -1261,7 +1426,7 @@ network_connect_child_read_cb (void *arg_hook_connect, int fd)
                     (void) (HOOK_CONNECT(hook_connect, callback))
                         (hook_connect->callback_data,
                          WEECHAT_HOOK_CONNECT_GNUTLS_HANDSHAKE_ERROR,
-                         rc,
+                         rc, sock,
                          "Error in the certificate.",
                          cb_ip_address);
                     unhook (hook_connect);
@@ -1303,7 +1468,14 @@ network_connect_child_read_cb (void *arg_hook_connect, int fd)
         }
         (void) (HOOK_CONNECT(hook_connect, callback))
             (hook_connect->callback_data, buffer[0] - '0', 0,
-             cb_error, cb_ip_address);
+             sock, cb_error, cb_ip_address);
+        unhook (hook_connect);
+    }
+    else
+    {
+        (void) (HOOK_CONNECT(hook_connect, callback))
+            (hook_connect->callback_data, WEECHAT_HOOK_CONNECT_MEMORY_ERROR,
+             0, sock, cb_error, cb_ip_address);
         unhook (hook_connect);
     }
 
@@ -1323,6 +1495,11 @@ void
 network_connect_with_fork (struct t_hook *hook_connect)
 {
     int child_pipe[2];
+#ifdef HOOK_CONNECT_MAX_SOCKETS
+    int i;
+#else
+    int child_socket[2];
+#endif
 #ifdef HAVE_GNUTLS
     int rc;
     const char *pos_error;
@@ -1338,7 +1515,7 @@ network_connect_with_fork (struct t_hook *hook_connect)
             (void) (HOOK_CONNECT(hook_connect, callback))
                 (hook_connect->callback_data,
                  WEECHAT_HOOK_CONNECT_GNUTLS_INIT_ERROR,
-                 0, NULL, NULL);
+                 0, -1, NULL, NULL);
             unhook (hook_connect);
             return;
         }
@@ -1350,7 +1527,7 @@ network_connect_with_fork (struct t_hook *hook_connect)
             (void) (HOOK_CONNECT(hook_connect, callback))
                 (hook_connect->callback_data,
                  WEECHAT_HOOK_CONNECT_GNUTLS_INIT_ERROR,
-                 0, _("invalid priorities"), NULL);
+                 0, -1, _("invalid priorities"), NULL);
             unhook (hook_connect);
             return;
         }
@@ -1368,13 +1545,34 @@ network_connect_with_fork (struct t_hook *hook_connect)
         (void) (HOOK_CONNECT(hook_connect, callback))
             (hook_connect->callback_data,
              WEECHAT_HOOK_CONNECT_MEMORY_ERROR,
-             0, NULL, NULL);
+             0, -1, NULL, NULL);
         unhook (hook_connect);
         return;
     }
     HOOK_CONNECT(hook_connect, child_read) = child_pipe[0];
     HOOK_CONNECT(hook_connect, child_write) = child_pipe[1];
 
+#ifndef HOOK_CONNECT_MAX_SOCKETS
+    /* create socket for child process */
+    if (socketpair (AF_LOCAL, SOCK_DGRAM, 0, child_socket) < 0)
+    {
+        (void) (HOOK_CONNECT(hook_connect, callback))
+            (hook_connect->callback_data,
+             WEECHAT_HOOK_CONNECT_MEMORY_ERROR,
+             0, -1, NULL, NULL);
+        unhook (hook_connect);
+        return;
+    }
+    HOOK_CONNECT(hook_connect, child_recv) = child_socket[0];
+    HOOK_CONNECT(hook_connect, child_send) = child_socket[1];
+#else
+    for (i = 0; i < HOOK_CONNECT_MAX_SOCKETS; i++)
+    {
+        HOOK_CONNECT(hook_connect, sock_v4[i]) = socket (AF_INET, SOCK_STREAM, 0);
+        HOOK_CONNECT(hook_connect, sock_v6[i]) = socket (AF_INET6, SOCK_STREAM, 0);
+    }
+#endif
+
     switch (pid = fork ())
     {
         /* fork failed */
@@ -1382,13 +1580,16 @@ network_connect_with_fork (struct t_hook *hook_connect)
             (void) (HOOK_CONNECT(hook_connect, callback))
                 (hook_connect->callback_data,
                  WEECHAT_HOOK_CONNECT_MEMORY_ERROR,
-                 0, NULL, NULL);
+                 0, -1, NULL, NULL);
             unhook (hook_connect);
             return;
         /* child process */
         case 0:
             setuid (getuid ());
             close (HOOK_CONNECT(hook_connect, child_read));
+#ifndef HOOK_CONNECT_MAX_SOCKETS
+            close (HOOK_CONNECT(hook_connect, child_recv));
+#endif
             network_connect_child (hook_connect);
             _exit (EXIT_SUCCESS);
     }
@@ -1396,6 +1597,10 @@ network_connect_with_fork (struct t_hook *hook_connect)
     HOOK_CONNECT(hook_connect, child_pid) = pid;
     close (HOOK_CONNECT(hook_connect, child_write));
     HOOK_CONNECT(hook_connect, child_write) = -1;
+#ifndef HOOK_CONNECT_MAX_SOCKETS
+    close (HOOK_CONNECT(hook_connect, child_send));
+    HOOK_CONNECT(hook_connect, child_send) = -1;
+#endif
     HOOK_CONNECT(hook_connect, hook_child_timer) = hook_timer (hook_connect->plugin,
                                                                CONFIG_INTEGER(config_network_connection_timeout) * 1000,
                                                                0, 1,
diff --git a/src/plugins/guile/weechat-guile-api.c b/src/plugins/guile/weechat-guile-api.c
index 071b3a0..7e0616e 100644
--- a/src/plugins/guile/weechat-guile-api.c
+++ b/src/plugins/guile/weechat-guile-api.c
@@ -2476,11 +2476,12 @@ weechat_guile_api_hook_process_hashtable (SCM command, SCM options, SCM timeout,
 
 int
 weechat_guile_api_hook_connect_cb (void *data, int status, int gnutls_rc,
-                                   const char *error, const char *ip_address)
+                                   int sock, const char *error,
+                                   const char *ip_address)
 {
     struct t_plugin_script_cb *script_callback;
-    void *func_argv[5];
-    char str_status[32], str_gnutls_rc[32];
+    void *func_argv[6];
+    char str_status[32], str_gnutls_rc[32], str_sock[32];
     char empty_arg[1] = { '\0' };
     int *rc, ret;
 
@@ -2490,17 +2491,19 @@ weechat_guile_api_hook_connect_cb (void *data, int status, int gnutls_rc,
     {
         snprintf (str_status, sizeof (str_status), "%d", status);
         snprintf (str_gnutls_rc, sizeof (str_gnutls_rc), "%d", gnutls_rc);
+        snprintf (str_sock, sizeof (str_sock), "%d", sock);
 
         func_argv[0] = (script_callback->data) ? script_callback->data : empty_arg;
         func_argv[1] = str_status;
         func_argv[2] = str_gnutls_rc;
-        func_argv[3] = (ip_address) ? (char *)ip_address : empty_arg;
-        func_argv[4] = (error) ? (char *)error : empty_arg;
+        func_argv[3] = str_sock;
+        func_argv[4] = (ip_address) ? (char *)ip_address : empty_arg;
+        func_argv[5] = (error) ? (char *)error : empty_arg;
 
         rc = (int *) weechat_guile_exec (script_callback->script,
                                          WEECHAT_SCRIPT_EXEC_INT,
                                          script_callback->function,
-                                         "sssss", func_argv);
+                                         "ssssss", func_argv);
 
         if (!rc)
             ret = WEECHAT_RC_ERROR;
@@ -2521,8 +2524,8 @@ weechat_guile_api_hook_connect_cb (void *data, int status, int gnutls_rc,
  */
 
 SCM
-weechat_guile_api_hook_connect (SCM proxy, SCM address, SCM port, SCM sock,
-                                SCM ipv6, SCM local_hostname, SCM function,
+weechat_guile_api_hook_connect (SCM proxy, SCM address, SCM port, SCM ipv6,
+                                SCM retry, SCM local_hostname, SCM function,
                                 SCM data)
 {
     char *result;
@@ -2530,8 +2533,8 @@ weechat_guile_api_hook_connect (SCM proxy, SCM address, SCM port, SCM sock,
 
     API_FUNC(1, "hook_connect", API_RETURN_EMPTY);
     if (!scm_is_string (proxy) || !scm_is_string (address)
-        || !scm_is_integer (port) || !scm_is_integer (sock)
-        || !scm_is_integer (ipv6) || !scm_is_string (local_hostname)
+        || !scm_is_integer (port) || !scm_is_integer (ipv6)
+        || !scm_is_integer (retry) || !scm_is_string (local_hostname)
         || !scm_is_string (function) || !scm_is_string (data))
         API_WRONG_ARGS(API_RETURN_EMPTY);
 
@@ -2540,8 +2543,8 @@ weechat_guile_api_hook_connect (SCM proxy, SCM address, SCM port, SCM sock,
                                                          scm_i_string_chars (proxy),
                                                          scm_i_string_chars (address),
                                                          scm_to_int (port),
-                                                         scm_to_int (sock),
                                                          scm_to_int (ipv6),
+                                                         scm_to_int (retry),
                                                          NULL, /* gnutls session */
                                                          NULL, /* gnutls callback */
                                                          0,    /* gnutls DH key size */
@@ -5567,6 +5570,7 @@ weechat_guile_api_module_init (void *data)
     scm_c_define ("weechat:WEECHAT_HOOK_CONNECT_GNUTLS_HANDSHAKE_ERROR", scm_from_int (WEECHAT_HOOK_CONNECT_GNUTLS_HANDSHAKE_ERROR));
     scm_c_define ("weechat:WEECHAT_HOOK_CONNECT_MEMORY_ERROR", scm_from_int (WEECHAT_HOOK_CONNECT_MEMORY_ERROR));
     scm_c_define ("weechat:WEECHAT_HOOK_CONNECT_TIMEOUT", scm_from_int (WEECHAT_HOOK_CONNECT_TIMEOUT));
+    scm_c_define ("weechat:WEECHAT_HOOK_CONNECT_SOCKET_ERROR", scm_from_int (WEECHAT_HOOK_CONNECT_SOCKET_ERROR));
 
     scm_c_define ("weechat:WEECHAT_HOOK_SIGNAL_STRING", scm_from_locale_string (WEECHAT_HOOK_SIGNAL_STRING));
     scm_c_define ("weechat:WEECHAT_HOOK_SIGNAL_INT", scm_from_locale_string (WEECHAT_HOOK_SIGNAL_INT));
@@ -5608,6 +5612,7 @@ weechat_guile_api_module_init (void *data)
                   "weechat:WEECHAT_HOOK_CONNECT_GNUTLS_HANDSHAKE_ERROR",
                   "weechat:WEECHAT_HOOK_CONNECT_MEMORY_ERROR",
                   "weechat:WEECHAT_HOOK_CONNECT_TIMEOUT",
+                  "weechat:WEECHAT_HOOK_CONNECT_SOCKET_ERROR",
                   "weechat:WEECHAT_HOOK_SIGNAL_STRING",
                   "weechat:WEECHAT_HOOK_SIGNAL_INT",
                   "weechat:WEECHAT_HOOK_SIGNAL_POINTER",
diff --git a/src/plugins/irc/irc-server.c b/src/plugins/irc/irc-server.c
index 174dbd0..93a1dc4 100644
--- a/src/plugins/irc/irc-server.c
+++ b/src/plugins/irc/irc-server.c
@@ -362,6 +362,11 @@ irc_server_set_addresses (struct t_irc_server *server, const char *addresses)
         free (server->ports_array);
         server->ports_array = NULL;
     }
+    if (server->retry_array)
+    {
+        free (server->retry_array);
+        server->retry_array = NULL;
+    }
 
     /* set new addresses/ports */
     if (addresses && addresses[0])
@@ -370,6 +375,7 @@ irc_server_set_addresses (struct t_irc_server *server, const char *addresses)
                                                         ",", 0, 0,
                                                         &server->addresses_count);
         server->ports_array = malloc (server->addresses_count * sizeof (server->ports_array[0]));
+        server->retry_array = malloc (server->addresses_count * sizeof (server->retry_array[0]));
         for (i = 0; i < server->addresses_count; i++)
         {
             pos = strchr (server->addresses_array[i], '/');
@@ -386,6 +392,7 @@ irc_server_set_addresses (struct t_irc_server *server, const char *addresses)
             {
                 server->ports_array[i] = IRC_SERVER_DEFAULT_PORT;
             }
+            server->retry_array[i] = 0;
         }
     }
 }
@@ -401,13 +408,19 @@ irc_server_set_index_current_address (struct t_irc_server *server, int index)
     {
         free (server->current_address);
         server->current_address = NULL;
+
+        /* copy current retry value before loading next server */
+        if (server->index_current_address < server->addresses_count)
+            server->retry_array[server->index_current_address] = server->current_retry;
     }
     server->current_port = 0;
+    server->current_retry = 0;
 
     index %= server->addresses_count;
     server->index_current_address = index;
     server->current_address = strdup (server->addresses_array[index]);
     server->current_port = server->ports_array[index];
+    server->current_retry = server->retry_array[index];
 }
 
 /*
@@ -857,10 +870,12 @@ irc_server_alloc (const char *name)
     new_server->addresses_count = 0;
     new_server->addresses_array = NULL;
     new_server->ports_array = NULL;
+    new_server->retry_array = NULL;
     new_server->index_current_address = 0;
     new_server->current_address = NULL;
     new_server->current_ip = NULL;
     new_server->current_port = 0;
+    new_server->current_retry = 0;
     new_server->sock = -1;
     new_server->hook_connect = NULL;
     new_server->hook_fd = NULL;
@@ -1317,6 +1332,8 @@ irc_server_free_data (struct t_irc_server *server)
         weechat_string_free_split (server->addresses_array);
     if (server->ports_array)
         free (server->ports_array);
+    if (server->retry_array)
+        free (server->retry_array);
     if (server->current_address)
         free (server->current_address);
     if (server->current_ip)
@@ -2972,7 +2989,7 @@ irc_server_switch_address (struct t_irc_server *server, int connection)
  */
 
 int
-irc_server_connect_cb (void *data, int status, int gnutls_rc,
+irc_server_connect_cb (void *data, int status, int gnutls_rc, int sock,
                        const char *error, const char *ip_address)
 {
     struct t_irc_server *server;
@@ -2987,6 +3004,7 @@ irc_server_connect_cb (void *data, int status, int gnutls_rc,
     switch (status)
     {
         case WEECHAT_HOOK_CONNECT_OK:
+            server->sock = sock;
             /* login to server */
             if (server->current_ip)
                 free (server->current_ip);
@@ -3051,6 +3069,7 @@ irc_server_connect_cb (void *data, int status, int gnutls_rc,
                                 error);
             }
             irc_server_close_connection (server);
+server->current_retry++;
             irc_server_switch_address (server, 1);
             break;
         case WEECHAT_HOOK_CONNECT_PROXY_ERROR:
@@ -3097,6 +3116,7 @@ irc_server_connect_cb (void *data, int status, int gnutls_rc,
                                 error);
             }
             irc_server_close_connection (server);
+            server->current_retry++;
             irc_server_reconnect_schedule (server);
             break;
         case WEECHAT_HOOK_CONNECT_GNUTLS_HANDSHAKE_ERROR:
@@ -3126,6 +3146,7 @@ irc_server_connect_cb (void *data, int status, int gnutls_rc,
             (void) gnutls_rc;
 #endif
             irc_server_close_connection (server);
+            server->current_retry++;
             irc_server_switch_address (server, 1);
             break;
         case WEECHAT_HOOK_CONNECT_MEMORY_ERROR:
@@ -3154,6 +3175,22 @@ irc_server_connect_cb (void *data, int status, int gnutls_rc,
                                 error);
             }
             irc_server_close_connection (server);
+            server->current_retry++;
+            irc_server_reconnect_schedule (server);
+            break;
+        case WEECHAT_HOOK_CONNECT_SOCKET_ERROR:
+            weechat_printf (server->buffer,
+                            _("%s%s: unable to create socket"),
+                            weechat_prefix ("error"), IRC_PLUGIN_NAME);
+            if (error && error[0])
+            {
+                weechat_printf (server->buffer,
+                                _("%s%s: error: %s"),
+                                weechat_prefix ("error"), IRC_PLUGIN_NAME,
+                                error);
+            }
+            irc_server_close_connection (server);
+            server->current_retry++;
             irc_server_reconnect_schedule (server);
             break;
     }
@@ -3557,7 +3594,7 @@ irc_server_gnutls_callback (void *data, gnutls_session_t tls_session,
 int
 irc_server_connect (struct t_irc_server *server)
 {
-    int set, length, flags;
+    int length;
     char *option_name;
     struct t_config_option *proxy_type, *proxy_ipv6, *proxy_address, *proxy_port;
     const char *proxy, *str_proxy_type, *str_proxy_address;
@@ -3674,26 +3711,22 @@ irc_server_connect (struct t_irc_server *server)
     if (proxy_type)
     {
         weechat_printf (server->buffer,
-                        _("%s%s: connecting to server %s/%d%s%s via %s "
+                        _("%s%s: connecting to server %s/%d%s via %s "
                           "proxy %s/%d%s..."),
                         weechat_prefix ("network"),
                         IRC_PLUGIN_NAME,
                         server->current_address,
                         server->current_port,
-                        (IRC_SERVER_OPTION_BOOLEAN(server, IRC_SERVER_OPTION_IPV6)) ?
-                        " (IPv6)" : "",
                         (IRC_SERVER_OPTION_BOOLEAN(server, IRC_SERVER_OPTION_SSL)) ?
                         " (SSL)" : "",
                         str_proxy_type,
                         str_proxy_address,
                         weechat_config_integer (proxy_port),
                         (weechat_config_boolean (proxy_ipv6)) ? " (IPv6)" : "");
-        weechat_log_printf (_("Connecting to server %s/%d%s%s via %s proxy "
+        weechat_log_printf (_("Connecting to server %s/%d%s via %s proxy "
                               "%s/%d%s..."),
                             server->current_address,
                             server->current_port,
-                            (IRC_SERVER_OPTION_BOOLEAN(server, IRC_SERVER_OPTION_IPV6)) ?
-                            " (IPv6)" : "",
                             (IRC_SERVER_OPTION_BOOLEAN(server, IRC_SERVER_OPTION_SSL)) ?
                             " (SSL)" : "",
                             str_proxy_type,
@@ -3704,22 +3737,18 @@ irc_server_connect (struct t_irc_server *server)
     else
     {
         weechat_printf (server->buffer,
-                        _("%s%s: connecting to server %s/%d%s%s..."),
+                        _("%s%s: connecting to server %s/%d%s..."),
                         weechat_prefix ("network"),
                         IRC_PLUGIN_NAME,
                         server->current_address,
                         server->current_port,
-                        (IRC_SERVER_OPTION_BOOLEAN(server, IRC_SERVER_OPTION_IPV6)) ?
-                        " (IPv6)" : "",
                         (IRC_SERVER_OPTION_BOOLEAN(server, IRC_SERVER_OPTION_SSL)) ?
                         " (SSL)" : "");
-        weechat_log_printf (_("%s%s: connecting to server %s/%d%s%s..."),
+        weechat_log_printf (_("%s%s: connecting to server %s/%d%s..."),
                             "",
                             IRC_PLUGIN_NAME,
                             server->current_address,
                             server->current_port,
-                            (IRC_SERVER_OPTION_BOOLEAN(server, IRC_SERVER_OPTION_IPV6)) ?
-                            " (IPv6)" : "",
                             (IRC_SERVER_OPTION_BOOLEAN(server, IRC_SERVER_OPTION_SSL)) ?
                             " (SSL)" : "");
     }
@@ -3727,55 +3756,6 @@ irc_server_connect (struct t_irc_server *server)
     /* close connection if opened */
     irc_server_close_connection (server);
 
-    /* create socket and set options */
-    if (proxy_type)
-    {
-        server->sock = socket ((weechat_config_integer (proxy_ipv6)) ?
-                               AF_INET6 : AF_INET,
-                               SOCK_STREAM, 0);
-    }
-    else
-    {
-        server->sock = socket ((IRC_SERVER_OPTION_BOOLEAN(server, IRC_SERVER_OPTION_IPV6)) ?
-                               AF_INET6 : AF_INET,
-                               SOCK_STREAM, 0);
-    }
-    if (server->sock == -1)
-    {
-        weechat_printf (server->buffer,
-                        _("%s%s: cannot create socket"),
-                        weechat_prefix ("error"), IRC_PLUGIN_NAME);
-        return 0;
-    }
-
-    /* set SO_REUSEADDR option for socket */
-    set = 1;
-    if (setsockopt (server->sock, SOL_SOCKET, SO_REUSEADDR,
-        (void *) &set, sizeof (set)) == -1)
-    {
-        weechat_printf (server->buffer,
-                        _("%s%s: cannot set socket option "
-                          "\"SO_REUSEADDR\""),
-                        weechat_prefix ("error"), IRC_PLUGIN_NAME);
-    }
-
-    /* set SO_KEEPALIVE option for socket */
-    set = 1;
-    if (setsockopt (server->sock, SOL_SOCKET, SO_KEEPALIVE,
-        (void *) &set, sizeof (set)) == -1)
-    {
-        weechat_printf (server->buffer,
-                        _("%s%s: cannot set socket option "
-                          "\"SO_KEEPALIVE\""),
-                        weechat_prefix ("error"), IRC_PLUGIN_NAME);
-    }
-
-    /* set flag O_NONBLOCK on socket */
-    flags = fcntl (server->sock, F_GETFL);
-    if (flags == -1)
-        flags = 0;
-    fcntl (server->sock, F_SETFL, flags | O_NONBLOCK);
-
     /* init SSL if asked and connect */
     server->ssl_connected = 0;
 #ifdef HAVE_GNUTLS
@@ -3784,8 +3764,9 @@ irc_server_connect (struct t_irc_server *server)
     server->hook_connect = weechat_hook_connect (proxy,
                                                  server->current_address,
                                                  server->current_port,
-                                                 server->sock,
-                                                 IRC_SERVER_OPTION_BOOLEAN(server, IRC_SERVER_OPTION_IPV6),
+                                                 proxy_type ? weechat_config_integer (proxy_ipv6)
+                                                 : IRC_SERVER_OPTION_BOOLEAN(server, IRC_SERVER_OPTION_IPV6),
+                                                 server->current_retry,
                                                  (server->ssl_connected) ? &server->gnutls_sess : NULL,
                                                  (server->ssl_connected) ? irc_server_gnutls_callback : NULL,
                                                  IRC_SERVER_OPTION_INTEGER(server, IRC_SERVER_OPTION_SSL_DHKEY_SIZE),
@@ -3797,7 +3778,9 @@ irc_server_connect (struct t_irc_server *server)
     server->hook_connect = weechat_hook_connect (proxy,
                                                  server->current_address,
                                                  server->current_port,
-                                                 server->sock,
+                                                 proxy_type ? weechat_config_integer (proxy_ipv6)
+                                                 : IRC_SERVER_OPTION_BOOLEAN(server, IRC_SERVER_OPTION_IPV6),
+                                                 server->current_retry,
                                                  IRC_SERVER_OPTION_BOOLEAN(server, IRC_SERVER_OPTION_IPV6),
                                                  NULL, NULL, 0, NULL,
                                                  IRC_SERVER_OPTION_STRING(server, IRC_SERVER_OPTION_LOCAL_HOSTNAME),
@@ -3899,6 +3882,9 @@ irc_server_disconnect (struct t_irc_server *server, int switch_address,
                         IRC_PLUGIN_NAME);
     }
 
+    if (reconnect)
+        server->current_retry++;
+
     if (switch_address)
         irc_server_switch_address (server, 0);
     else
@@ -4375,10 +4361,12 @@ irc_server_hdata_server_cb (void *data, const char *hdata_name)
         WEECHAT_HDATA_VAR(struct t_irc_server, addresses_count, INTEGER, 0, NULL, NULL);
         WEECHAT_HDATA_VAR(struct t_irc_server, addresses_array, STRING, 0, "addresses_count", NULL);
         WEECHAT_HDATA_VAR(struct t_irc_server, ports_array, INTEGER, 0, "addresses_count", NULL);
+        WEECHAT_HDATA_VAR(struct t_irc_server, retry_array, INTEGER, 0, "addresses_count", NULL);
         WEECHAT_HDATA_VAR(struct t_irc_server, index_current_address, INTEGER, 0, NULL, NULL);
         WEECHAT_HDATA_VAR(struct t_irc_server, current_address, STRING, 0, NULL, NULL);
         WEECHAT_HDATA_VAR(struct t_irc_server, current_ip, STRING, 0, NULL, NULL);
         WEECHAT_HDATA_VAR(struct t_irc_server, current_port, INTEGER, 0, NULL, NULL);
+        WEECHAT_HDATA_VAR(struct t_irc_server, current_retry, INTEGER, 0, NULL, NULL);
         WEECHAT_HDATA_VAR(struct t_irc_server, sock, INTEGER, 0, NULL, NULL);
         WEECHAT_HDATA_VAR(struct t_irc_server, hook_connect, POINTER, 0, NULL, "hook");
         WEECHAT_HDATA_VAR(struct t_irc_server, hook_fd, POINTER, 0, NULL, "hook");
@@ -4575,6 +4563,8 @@ irc_server_add_to_infolist (struct t_infolist *infolist,
         return 0;
     if (!weechat_infolist_new_var_integer (ptr_item, "current_port", server->current_port))
         return 0;
+    if (!weechat_infolist_new_var_integer (ptr_item, "current_retry", server->current_retry))
+        return 0;
     if (!weechat_infolist_new_var_integer (ptr_item, "sock", server->sock))
         return 0;
     if (!weechat_infolist_new_var_integer (ptr_item, "is_connected", server->is_connected))
@@ -4888,10 +4878,12 @@ irc_server_print_log ()
         weechat_log_printf ("  addresses_count. . . : %d",    ptr_server->addresses_count);
         weechat_log_printf ("  addresses_array. . . : 0x%lx", ptr_server->addresses_array);
         weechat_log_printf ("  ports_array. . . . . : 0x%lx", ptr_server->ports_array);
+        weechat_log_printf ("  retry_array. . . . . : 0x%lx", ptr_server->retry_array);
         weechat_log_printf ("  index_current_address: %d",    ptr_server->index_current_address);
         weechat_log_printf ("  current_address. . . : '%s'",  ptr_server->current_address);
         weechat_log_printf ("  current_ip . . . . . : '%s'",  ptr_server->current_ip);
         weechat_log_printf ("  current_port . . . . : %d",    ptr_server->current_port);
+        weechat_log_printf ("  current_retry. . . . : %u",    ptr_server->current_retry);
         weechat_log_printf ("  sock . . . . . . . . : %d",    ptr_server->sock);
         weechat_log_printf ("  hook_connect . . . . : 0x%lx", ptr_server->hook_connect);
         weechat_log_printf ("  hook_fd. . . . . . . : 0x%lx", ptr_server->hook_fd);
diff --git a/src/plugins/irc/irc-server.h b/src/plugins/irc/irc-server.h
index 09856a1..fd2f604 100644
--- a/src/plugins/irc/irc-server.h
+++ b/src/plugins/irc/irc-server.h
@@ -140,11 +140,14 @@ struct t_irc_server
     int addresses_count;            /* number of addresses                   */
     char **addresses_array;         /* addresses (after split)               */
     int *ports_array;               /* ports for addresses                   */
+    unsigned int *retry_array;      /* retry count per address               */
     int index_current_address;      /* current address index in array        */
     char *current_address;          /* current address                       */
     char *current_ip;               /* current IP address                    */
     int current_port;               /* current port                          */
-    int sock;                       /* socket for server (IPv4 or IPv6)      */
+    unsigned int current_retry;     /* current retry count (increment if a   */
+                                    /* connected server fails in any way)    */
+    int sock;                       /* socket for server                     */
     struct t_hook *hook_connect;    /* connection hook                       */
     struct t_hook *hook_fd;         /* hook for server socket                */
     struct t_hook *hook_timer_connection; /* timer for connection            */
